/**
 * Assignment #6: Page Replacement Algorithms
 * Sample Solution
 *
 * Instructor: Ron Mak
 * CMPE 142 Operating Systems
 * Computer Engineering Department
 * San Jose State University
 */
#include "Optimal.h"

using namespace std;

int    Optimal::total_hit_count  = 0;
double Optimal::total_swap_count = 0;

void Optimal::init()
{
}

void Optimal::load_page(const int ref)
{
}

int Optimal::choose_victim_frame(const int ref_index)
{
    vector<int> indexes(frame_count, ref_string.size());

    for (int frame_index = 0; frame_index < frame_count; frame_index++)
    {
        int ref = frames[frame_index];

        for (int i = ref_index + 1; i < ref_string.size(); i++)
        {
            if (ref == ref_string[i])
            {
                indexes[frame_index] = i;
                break;
            }
        }
    }

    int highest_index = 0;
    int longest_frame;

    for (int i = 0; i < indexes.size(); i++)
    {
        if (indexes[i] > highest_index)
        {
            highest_index = indexes[i];
            longest_frame = i;
        }
    }

    return longest_frame;
}

void Optimal::record_hit()
{
    ++total_hit_count;
}

void Optimal::record_swap(double amount)
{
    total_swap_count += amount;
}
